import "./cljs_env.js";
goog.provide('nextjournal.clojure_mode.extensions.close_brackets');
var module$node_modules$w3c_keyname$index_cjs=shadow.js.require("module$node_modules$w3c_keyname$index_cjs", {});
var module$node_modules$$codemirror$view$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$view$dist$index_cjs", {});
var module$node_modules$$codemirror$state$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$state$dist$index_cjs", {});
var module$node_modules$$codemirror$text$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$text$dist$index_cjs", {});
nextjournal.clojure_mode.extensions.close_brackets.in_string_QMARK_ = (function nextjournal$clojure_mode$extensions$close_brackets$in_string_QMARK_(state,pos){
var G__86151 = nextjournal.clojure_mode.node.name(nextjournal.clojure_mode.node.tree.cljs$core$IFn$_invoke$arity$2(state,pos));
var fexpr__86150 = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, ["StringContent",null,"String",null], null), null);
return (fexpr__86150.cljs$core$IFn$_invoke$arity$1 ? fexpr__86150.cljs$core$IFn$_invoke$arity$1(G__86151) : fexpr__86150.call(null,G__86151));
});
nextjournal.clojure_mode.extensions.close_brackets.escaped_QMARK_ = (function nextjournal$clojure_mode$extensions$close_brackets$escaped_QMARK_(state,pos){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("\\",state.doc.slice((function (){var x__4306__auto__ = (0);
var y__4307__auto__ = (pos - (1));
return ((x__4306__auto__ > y__4307__auto__) ? x__4306__auto__ : y__4307__auto__);
})(),pos).toString());
});
nextjournal.clojure_mode.extensions.close_brackets.backspace_backoff = (function nextjournal$clojure_mode$extensions$close_brackets$backspace_backoff(state,from,to){
if(cljs.core.truth_((function (){var and__4221__auto__ = (function (){var G__86163 = nextjournal.clojure_mode.node.node_BAR_(state,(from - (1)));
if((G__86163 == null)){
return null;
} else {
return nextjournal.clojure_mode.util.guard(G__86163,nextjournal.clojure_mode.node.line_comment_QMARK_);
}
})();
if(cljs.core.truth_(and__4221__auto__)){
return (!(clojure.string.blank_QMARK_(nextjournal.clojure_mode.util.line_content_at(state,from))));
} else {
return and__4221__auto__;
}
})())){
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),(from - (1))], null);
} else {
return nextjournal.clojure_mode.util.deletion.cljs$core$IFn$_invoke$arity$2(from,to);
}
});
/**
 * - skips over closing brackets
 * - when deleting an opening bracket of an empty list, removes both brackets
 */
nextjournal.clojure_mode.extensions.close_brackets.handle_backspace = (function nextjournal$clojure_mode$extensions$close_brackets$handle_backspace(p__86164){
var map__86165 = p__86164;
var map__86165__$1 = (((((!((map__86165 == null))))?(((((map__86165.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__86165.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__86165):map__86165);
var state = map__86165__$1;
var doc = (function (){var obj86186 = map__86165__$1;
var k86187 = "doc";
if((function (){var obj86188 = obj86186;
return (((!((obj86188 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86187,obj86188)));
})()){
return (obj86186[k86187]);
} else {
return undefined;
}
})();
if(cljs.core.truth_((function (){var and__4221__auto__ = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((1),state.selection.ranges.length);
if(and__4221__auto__){
var range = (function (){var obj86196 = (function (){var obj86194 = (function (){var obj86192 = state;
var k86193 = "selection";
if((function (){var obj86198 = obj86192;
return (((!((obj86198 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86193,obj86198)));
})()){
return (obj86192[k86193]);
} else {
return undefined;
}
})();
var k86195 = "ranges";
if((function (){var obj86202 = obj86194;
return (((!((obj86202 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86195,obj86202)));
})()){
return (obj86194[k86195]);
} else {
return undefined;
}
})();
var k86197 = (0);
if((function (){var obj86203 = obj86196;
return (((!((obj86203 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86197,obj86203)));
})()){
return (obj86196[k86197]);
} else {
return undefined;
}
})();
var and__4221__auto____$1 = range.empty;
if(cljs.core.truth_(and__4221__auto____$1)){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((0),range.from);
} else {
return and__4221__auto____$1;
}
} else {
return and__4221__auto__;
}
})())){
return null;
} else {
return nextjournal.clojure_mode.util.update_ranges.cljs$core$IFn$_invoke$arity$3(state,({"annotations": nextjournal.clojure_mode.util.user_event_annotation("delete")}),(function (p__86214){
var map__86216 = p__86214;
var map__86216__$1 = (((((!((map__86216 == null))))?(((((map__86216.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__86216.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__86216):map__86216);
var range = map__86216__$1;
var head = (function (){var obj86219 = map__86216__$1;
var k86220 = "head";
if((function (){var obj86223 = obj86219;
return (((!((obj86223 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86220,obj86223)));
})()){
return (obj86219[k86220]);
} else {
return undefined;
}
})();
var empty = (function (){var obj86225 = map__86216__$1;
var k86226 = "empty";
if((function (){var obj86227 = obj86225;
return (((!((obj86227 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86226,obj86227)));
})()){
return (obj86225[k86226]);
} else {
return undefined;
}
})();
var anchor = (function (){var obj86228 = map__86216__$1;
var k86229 = "anchor";
if((function (){var obj86230 = obj86228;
return (((!((obj86230 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86229,obj86230)));
})()){
return (obj86228[k86229]);
} else {
return undefined;
}
})();
var map__86233 = nextjournal.clojure_mode.util.from_to(head,anchor);
var map__86233__$1 = (((((!((map__86233 == null))))?(((((map__86233.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__86233.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__86233):map__86233);
var range__$1 = map__86233__$1;
var from = (function (){var obj86236 = map__86233__$1;
var k86237 = "from";
if((function (){var obj86238 = obj86236;
return (((!((obj86238 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86237,obj86238)));
})()){
return (obj86236[k86237]);
} else {
return undefined;
}
})();
var to = (function (){var obj86239 = map__86233__$1;
var k86240 = "to";
if((function (){var obj86242 = obj86239;
return (((!((obj86242 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86240,obj86242)));
})()){
return (obj86239[k86240]);
} else {
return undefined;
}
})();
var node_BAR_ = nextjournal.clojure_mode.node.tree.cljs$core$IFn$_invoke$arity$1(state).resolve(from,(-1));
var parent = node_BAR_.parent;
if(cljs.core.truth_((function (){var or__4223__auto__ = cljs.core.not(empty);
if(or__4223__auto__){
return or__4223__auto__;
} else {
var or__4223__auto____$1 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("StringContent",nextjournal.clojure_mode.node.name(nextjournal.clojure_mode.node.tree.cljs$core$IFn$_invoke$arity$3(state,from,(-1))));
if(or__4223__auto____$1){
return or__4223__auto____$1;
} else {
var and__4221__auto__ = parent;
if(cljs.core.truth_(and__4221__auto__)){
return (((!(nextjournal.clojure_mode.node.balanced_QMARK_(parent)))) && (nextjournal.clojure_mode.node.left_edge_QMARK_(node_BAR_)));
} else {
return and__4221__auto__;
}
}
}
})())){
return nextjournal.clojure_mode.util.deletion.cljs$core$IFn$_invoke$arity$2(from,to);
} else {
if(((nextjournal.clojure_mode.node.right_edge_QMARK_(node_BAR_)) && ((from === nextjournal.clojure_mode.node.end(parent))))){
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),(from - (1))], null);
} else {
if(((((nextjournal.clojure_mode.node.start_edge_QMARK_(node_BAR_)) || (nextjournal.clojure_mode.node.same_edge_QMARK_(node_BAR_)))) && ((nextjournal.clojure_mode.node.start(node_BAR_) === nextjournal.clojure_mode.node.start(parent))))){
if(nextjournal.clojure_mode.node.empty_QMARK_(nextjournal.clojure_mode.node.up(node_BAR_))){
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),nextjournal.clojure_mode.node.start(parent),new cljs.core.Keyword(null,"changes","changes",1492088),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [nextjournal.clojure_mode.util.from_to(nextjournal.clojure_mode.node.start(parent),nextjournal.clojure_mode.node.end(parent))], null)], null);
} else {
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),from], null);
}
} else {
return nextjournal.clojure_mode.extensions.close_brackets.backspace_backoff(state,from,to);

}
}
}
}));
}
});
nextjournal.clojure_mode.extensions.close_brackets.coll_pairs = new cljs.core.PersistentArrayMap(null, 4, ["(",")","[","]","{","}","\"","\""], null);
nextjournal.clojure_mode.extensions.close_brackets.handle_open = (function nextjournal$clojure_mode$extensions$close_brackets$handle_open(state,open){
var close = (nextjournal.clojure_mode.extensions.close_brackets.coll_pairs.cljs$core$IFn$_invoke$arity$1 ? nextjournal.clojure_mode.extensions.close_brackets.coll_pairs.cljs$core$IFn$_invoke$arity$1(open) : nextjournal.clojure_mode.extensions.close_brackets.coll_pairs.call(null,open));
return nextjournal.clojure_mode.util.update_ranges.cljs$core$IFn$_invoke$arity$3(state,({"annotations": nextjournal.clojure_mode.util.user_event_annotation("input")}),(function (p__86252){
var map__86253 = p__86252;
var map__86253__$1 = (((((!((map__86253 == null))))?(((((map__86253.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__86253.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__86253):map__86253);
var from = (function (){var obj86258 = map__86253__$1;
var k86259 = "from";
if((function (){var obj86260 = obj86258;
return (((!((obj86260 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86259,obj86260)));
})()){
return (obj86258[k86259]);
} else {
return undefined;
}
})();
var to = (function (){var obj86262 = map__86253__$1;
var k86263 = "to";
if((function (){var obj86264 = obj86262;
return (((!((obj86264 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86263,obj86264)));
})()){
return (obj86262[k86263]);
} else {
return undefined;
}
})();
var head = (function (){var obj86265 = map__86253__$1;
var k86266 = "head";
if((function (){var obj86267 = obj86265;
return (((!((obj86267 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86266,obj86267)));
})()){
return (obj86265[k86266]);
} else {
return undefined;
}
})();
var anchor = (function (){var obj86273 = map__86253__$1;
var k86274 = "anchor";
if((function (){var obj86275 = obj86273;
return (((!((obj86275 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86274,obj86275)));
})()){
return (obj86273[k86274]);
} else {
return undefined;
}
})();
var empty = (function (){var obj86278 = map__86253__$1;
var k86279 = "empty";
if((function (){var obj86281 = obj86278;
return (((!((obj86281 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86279,obj86281)));
})()){
return (obj86278[k86279]);
} else {
return undefined;
}
})();
if(cljs.core.truth_(nextjournal.clojure_mode.extensions.close_brackets.in_string_QMARK_(state,from))){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(open,"\"")){
return nextjournal.clojure_mode.util.insertion.cljs$core$IFn$_invoke$arity$2(head,"\\\"");
} else {
return nextjournal.clojure_mode.util.insertion.cljs$core$IFn$_invoke$arity$3(from,to,open);
}
} else {
if(nextjournal.clojure_mode.extensions.close_brackets.escaped_QMARK_(state,from)){
return nextjournal.clojure_mode.util.insertion.cljs$core$IFn$_invoke$arity$3(from,to,open);
} else {
if(cljs.core.truth_(empty)){
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"changes","changes",1492088),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"insert","insert",1286475395),[open,close].join(''),new cljs.core.Keyword(null,"from","from",1815293044),head], null),new cljs.core.Keyword(null,"cursor","cursor",1011937484),(head + ((open).length))], null);
} else {
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"changes","changes",1492088),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"insert","insert",1286475395),open,new cljs.core.Keyword(null,"from","from",1815293044),from], null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"insert","insert",1286475395),close,new cljs.core.Keyword(null,"from","from",1815293044),to], null)], null),new cljs.core.Keyword(null,"from-to","from-to",-640428401),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(anchor + ((open).length)),(head + ((open).length))], null)], null);
}

}
}
}));
});
nextjournal.clojure_mode.extensions.close_brackets.handle_close = (function nextjournal$clojure_mode$extensions$close_brackets$handle_close(state,key_name){
return nextjournal.clojure_mode.util.update_ranges.cljs$core$IFn$_invoke$arity$3(state,({"annotations": nextjournal.clojure_mode.util.user_event_annotation("input")}),(function (p__86296){
var map__86298 = p__86296;
var map__86298__$1 = (((((!((map__86298 == null))))?(((((map__86298.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__86298.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__86298):map__86298);
var range = map__86298__$1;
var empty = (function (){var obj86301 = map__86298__$1;
var k86302 = "empty";
if((function (){var obj86303 = obj86301;
return (((!((obj86303 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86302,obj86303)));
})()){
return (obj86301[k86302]);
} else {
return undefined;
}
})();
var head = (function (){var obj86307 = map__86298__$1;
var k86308 = "head";
if((function (){var obj86309 = obj86307;
return (((!((obj86309 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86308,obj86309)));
})()){
return (obj86307[k86308]);
} else {
return undefined;
}
})();
var from = (function (){var obj86310 = map__86298__$1;
var k86311 = "from";
if((function (){var obj86314 = obj86310;
return (((!((obj86314 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86311,obj86314)));
})()){
return (obj86310[k86311]);
} else {
return undefined;
}
})();
var to = (function (){var obj86316 = map__86298__$1;
var k86317 = "to";
if((function (){var obj86318 = obj86316;
return (((!((obj86318 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86317,obj86318)));
})()){
return (obj86316[k86317]);
} else {
return undefined;
}
})();
if(cljs.core.truth_((function (){var or__4223__auto__ = nextjournal.clojure_mode.extensions.close_brackets.in_string_QMARK_(state,from);
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return nextjournal.clojure_mode.extensions.close_brackets.escaped_QMARK_(state,from);
}
})())){
return nextjournal.clojure_mode.util.insertion.cljs$core$IFn$_invoke$arity$3(from,to,key_name);
} else {
if(cljs.core.truth_(empty)){
var or__4223__auto__ = (function (){var unbalanced = (function (){var G__86320 = nextjournal.clojure_mode.node.tree.cljs$core$IFn$_invoke$arity$3(state,head,(-1));
var G__86320__$1 = (((G__86320 == null))?null:nextjournal.clojure_mode.node.ancestors(G__86320));
var G__86320__$2 = (((G__86320__$1 == null))?null:cljs.core.filter.cljs$core$IFn$_invoke$arity$2(cljs.core.every_pred.cljs$core$IFn$_invoke$arity$2(nextjournal.clojure_mode.node.coll_QMARK_,cljs.core.complement(nextjournal.clojure_mode.node.balanced_QMARK_)),G__86320__$1));
if((G__86320__$2 == null)){
return null;
} else {
return cljs.core.first(G__86320__$2);
}
})();
var closing = (function (){var G__86323 = unbalanced;
var G__86323__$1 = (((G__86323 == null))?null:nextjournal.clojure_mode.node.down(G__86323));
if((G__86323__$1 == null)){
return null;
} else {
return nextjournal.clojure_mode.node.closed_by(G__86323__$1);
}
})();
var pos = (function (){var G__86324 = unbalanced;
if((G__86324 == null)){
return null;
} else {
return nextjournal.clojure_mode.node.end(G__86324);
}
})();
if(cljs.core.truth_((function (){var and__4221__auto__ = closing;
if(cljs.core.truth_(and__4221__auto__)){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(closing,key_name);
} else {
return and__4221__auto__;
}
})())){
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"changes","changes",1492088),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"from","from",1815293044),pos,new cljs.core.Keyword(null,"insert","insert",1286475395),closing], null),new cljs.core.Keyword(null,"cursor","cursor",1011937484),(pos + (1))], null);
} else {
return null;
}
})();
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
var or__4223__auto____$1 = (function (){var temp__5753__auto__ = (function (){var temp__5753__auto__ = nextjournal.clojure_mode.node.terminal_cursor(nextjournal.clojure_mode.node.tree.cljs$core$IFn$_invoke$arity$1(state),head,(1));
if(cljs.core.truth_(temp__5753__auto__)){
var cursor = temp__5753__auto__;
while(true){
if(nextjournal.clojure_mode.node.right_edge_type_QMARK_(cursor.type)){
return nextjournal.clojure_mode.node.end(cursor);
} else {
if(cljs.core.truth_(cursor.next())){
continue;
} else {
return null;
}
}
break;
}
} else {
return null;
}
})();
if(cljs.core.truth_(temp__5753__auto__)){
var close_node_end = temp__5753__auto__;
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),close_node_end], null);
} else {
return null;
}
})();
if(cljs.core.truth_(or__4223__auto____$1)){
return or__4223__auto____$1;
} else {
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),head], null);
}
}
} else {
return null;
}
}
}));
});
nextjournal.clojure_mode.extensions.close_brackets.handle_backspace_cmd = (function nextjournal$clojure_mode$extensions$close_brackets$handle_backspace_cmd(p__86327){
var map__86329 = p__86327;
var map__86329__$1 = (((((!((map__86329 == null))))?(((((map__86329.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__86329.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__86329):map__86329);
var view = map__86329__$1;
var state = (function (){var obj86334 = map__86329__$1;
var k86335 = "state";
if((function (){var obj86337 = obj86334;
return (((!((obj86337 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86335,obj86337)));
})()){
return (obj86334[k86335]);
} else {
return undefined;
}
})();
return nextjournal.clojure_mode.util.dispatch_some(view,nextjournal.clojure_mode.extensions.close_brackets.handle_backspace(state));
});
nextjournal.clojure_mode.extensions.close_brackets.handle_open_cmd = (function nextjournal$clojure_mode$extensions$close_brackets$handle_open_cmd(key_name){
return (function (p__86339){
var map__86342 = p__86339;
var map__86342__$1 = (((((!((map__86342 == null))))?(((((map__86342.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__86342.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__86342):map__86342);
var view = map__86342__$1;
var state = (function (){var obj86347 = map__86342__$1;
var k86348 = "state";
if((function (){var obj86349 = obj86347;
return (((!((obj86349 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86348,obj86349)));
})()){
return (obj86347[k86348]);
} else {
return undefined;
}
})();
return nextjournal.clojure_mode.util.dispatch_some(view,nextjournal.clojure_mode.extensions.close_brackets.handle_open(state,key_name));
});
});
nextjournal.clojure_mode.extensions.close_brackets.handle_close_cmd = (function nextjournal$clojure_mode$extensions$close_brackets$handle_close_cmd(key_name){
return (function (p__86351){
var map__86353 = p__86351;
var map__86353__$1 = (((((!((map__86353 == null))))?(((((map__86353.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__86353.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__86353):map__86353);
var view = map__86353__$1;
var state = (function (){var obj86357 = map__86353__$1;
var k86358 = "state";
if((function (){var obj86359 = obj86357;
return (((!((obj86359 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86358,obj86359)));
})()){
return (obj86357[k86358]);
} else {
return undefined;
}
})();
return nextjournal.clojure_mode.util.dispatch_some(view,nextjournal.clojure_mode.extensions.close_brackets.handle_close(state,key_name));
});
});
nextjournal.clojure_mode.extensions.close_brackets.extension = (function nextjournal$clojure_mode$extensions$close_brackets$extension(){
return module$node_modules$$codemirror$view$dist$index_cjs.keymap.of([({}),({"key":"(","run":nextjournal.clojure_mode.extensions.close_brackets.handle_open_cmd("(")}),({"key":"[","run":nextjournal.clojure_mode.extensions.close_brackets.handle_open_cmd("[")}),({"key":"{","run":nextjournal.clojure_mode.extensions.close_brackets.handle_open_cmd("{")}),({"key":"\"","run":nextjournal.clojure_mode.extensions.close_brackets.handle_open_cmd("\"")}),({"key":")","run":nextjournal.clojure_mode.extensions.close_brackets.handle_close_cmd(")")}),({"key":"]","run":nextjournal.clojure_mode.extensions.close_brackets.handle_close_cmd("]")}),({"key":"}","run":nextjournal.clojure_mode.extensions.close_brackets.handle_close_cmd("}")})]);
});

//# sourceMappingURL=nextjournal.clojure_mode.extensions.close_brackets.js.map
