import "./cljs_env.js";
goog.provide('nextjournal.clojure_mode.extensions.selection_history');
var module$node_modules$$codemirror$state$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$state$dist$index_cjs", {});
nextjournal.clojure_mode.extensions.selection_history.event_annotation = nextjournal.clojure_mode.util.user_event_annotation("selectionhistory");
nextjournal.clojure_mode.extensions.selection_history.second_last = (function nextjournal$clojure_mode$extensions$selection_history$second_last(arr){
if((arr.length > (1))){
return (arr[(arr.length - (1))]);
} else {
return null;
}
});
nextjournal.clojure_mode.extensions.selection_history.ser = (function nextjournal$clojure_mode$extensions$selection_history$ser(selection){
return cljs.core.map.cljs$core$IFn$_invoke$arity$2(cljs.core.juxt.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"anchor","anchor",1549638489),new cljs.core.Keyword(null,"head","head",-771383919)),new cljs.core.Keyword(null,"ranges","ranges",1887686682).cljs$core$IFn$_invoke$arity$1(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(selection.toJSON(),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"keywordize-keys","keywordize-keys",1310784252),true], 0))));
});
nextjournal.clojure_mode.extensions.selection_history.something_selected_QMARK_ = (function nextjournal$clojure_mode$extensions$selection_history$something_selected_QMARK_(selection){
return cljs.core.some((function (p1__85727_SHARP_){
return cljs.core.not(p1__85727_SHARP_.empty);
}),selection.ranges);
});
/**
 * Stores selection history
 */
nextjournal.clojure_mode.extensions.selection_history.selection_history_field = module$node_modules$$codemirror$state$dist$index_cjs.StateField.define(({"create": (function (state){
return (new cljs.core.List(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"selection","selection",975998651),state.selection], null),null,(1),null));
}), "update": (function (stack,p__85729){
var map__85731 = p__85729;
var map__85731__$1 = (((((!((map__85731 == null))))?(((((map__85731.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__85731.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__85731):map__85731);
var tr = map__85731__$1;
var map__85732 = (function (){var obj85734 = map__85731__$1;
var k85735 = "state";
if((function (){var obj85736 = obj85734;
return (((!((obj85736 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85735,obj85736)));
})()){
return (obj85734[k85735]);
} else {
return undefined;
}
})();
var map__85732__$1 = (((((!((map__85732 == null))))?(((((map__85732.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__85732.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__85732):map__85732);
var selection = (function (){var obj85739 = map__85732__$1;
var k85740 = "selection";
if((function (){var obj85741 = obj85739;
return (((!((obj85741 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85740,obj85741)));
})()){
return (obj85739[k85740]);
} else {
return undefined;
}
})();
var docChanged = (function (){var obj85742 = map__85731__$1;
var k85743 = "docChanged";
if((function (){var obj85744 = obj85742;
return (((!((obj85744 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85743,obj85744)));
})()){
return (obj85742[k85743]);
} else {
return undefined;
}
})();
var previous_position = cljs.core.first(cljs.core.keep_indexed.cljs$core$IFn$_invoke$arity$2((function (i,x){
if(cljs.core.truth_(nextjournal.clojure_mode.selections.eq_QMARK_(new cljs.core.Keyword(null,"selection","selection",975998651).cljs$core$IFn$_invoke$arity$1(x),selection))){
return i;
} else {
return null;
}
}),stack));
if(cljs.core.truth_(docChanged)){
return (new cljs.core.List(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"selection","selection",975998651),selection,new cljs.core.Keyword(null,"event","event",301435442),nextjournal.clojure_mode.util.get_user_event_annotation(tr)], null),null,(1),null));
} else {
if(cljs.core.not(nextjournal.clojure_mode.extensions.selection_history.something_selected_QMARK_(selection))){
return (new cljs.core.List(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"selection","selection",975998651),selection,new cljs.core.Keyword(null,"event","event",301435442),nextjournal.clojure_mode.util.get_user_event_annotation(tr)], null),null,(1),null));
} else {
if(cljs.core.truth_(previous_position)){
var vec__85746 = cljs.core.drop.cljs$core$IFn$_invoke$arity$2(previous_position,stack);
var seq__85747 = cljs.core.seq(vec__85746);
var first__85748 = cljs.core.first(seq__85747);
var seq__85747__$1 = cljs.core.next(seq__85747);
var f = first__85748;
var more = seq__85747__$1;
return cljs.core.cons(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(f,new cljs.core.Keyword(null,"prev-event","prev-event",-88694225),new cljs.core.Keyword(null,"event","event",301435442).cljs$core$IFn$_invoke$arity$1(cljs.core.first(stack))),more);
} else {
return cljs.core.cons(new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"selection","selection",975998651),selection,new cljs.core.Keyword(null,"event","event",301435442),nextjournal.clojure_mode.util.get_user_event_annotation(tr)], null),stack);

}
}
}
})}));
nextjournal.clojure_mode.extensions.selection_history.extension = (function nextjournal$clojure_mode$extensions$selection_history$extension(){
return nextjournal.clojure_mode.extensions.selection_history.selection_history_field;
});
nextjournal.clojure_mode.extensions.selection_history.stack = (function nextjournal$clojure_mode$extensions$selection_history$stack(state){
return state.field(nextjournal.clojure_mode.extensions.selection_history.selection_history_field);
});
nextjournal.clojure_mode.extensions.selection_history.grow_1 = (function nextjournal$clojure_mode$extensions$selection_history$grow_1(state,start,end){
var node = nextjournal.clojure_mode.node.nearest_touching(state,end,(-1));
return cljs.core.first(cljs.core.filter.cljs$core$IFn$_invoke$arity$2((function (p__85751){
var map__85752 = p__85751;
var map__85752__$1 = (((((!((map__85752 == null))))?(((((map__85752.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__85752.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__85752):map__85752);
var a_start = (function (){var obj85754 = map__85752__$1;
var k85755 = "from";
if((function (){var obj85756 = obj85754;
return (((!((obj85756 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85755,obj85756)));
})()){
return (obj85754[k85755]);
} else {
return undefined;
}
})();
var a_end = (function (){var obj85758 = map__85752__$1;
var k85759 = "to";
if((function (){var obj85760 = obj85758;
return (((!((obj85760 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85759,obj85760)));
})()){
return (obj85758[k85759]);
} else {
return undefined;
}
})();
return (((a_start <= start)) && ((((a_end >= end)) && ((!((((a_start === start)) && ((a_end === end)))))))));
}),cljs.core.cons(node,cljs.core.mapcat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.juxt.cljs$core$IFn$_invoke$arity$2(nextjournal.clojure_mode.node.inner_span,cljs.core.identity),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([nextjournal.clojure_mode.node.ancestors(node)], 0)))));
});
nextjournal.clojure_mode.extensions.selection_history.selection_grow_STAR_ = (function nextjournal$clojure_mode$extensions$selection_history$selection_grow_STAR_(state){
return nextjournal.clojure_mode.util.update_ranges.cljs$core$IFn$_invoke$arity$3(state,({"annotations": nextjournal.clojure_mode.extensions.selection_history.event_annotation}),(function (p__85762){
var map__85764 = p__85762;
var map__85764__$1 = (((((!((map__85764 == null))))?(((((map__85764.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__85764.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__85764):map__85764);
var range = map__85764__$1;
var from = (function (){var obj85766 = map__85764__$1;
var k85767 = "from";
if((function (){var obj85768 = obj85766;
return (((!((obj85768 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85767,obj85768)));
})()){
return (obj85766[k85767]);
} else {
return undefined;
}
})();
var to = (function (){var obj85769 = map__85764__$1;
var k85770 = "to";
if((function (){var obj85771 = obj85769;
return (((!((obj85771 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85770,obj85771)));
})()){
return (obj85769[k85770]);
} else {
return undefined;
}
})();
var empty = (function (){var obj85773 = map__85764__$1;
var k85774 = "empty";
if((function (){var obj85775 = obj85773;
return (((!((obj85775 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85774,obj85775)));
})()){
return (obj85773[k85774]);
} else {
return undefined;
}
})();
if(cljs.core.truth_(empty)){
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"range","range",1639692286),(function (){var or__4223__auto__ = (function (){var G__85776 = nextjournal.clojure_mode.node.nearest_touching(state,from,(-1));
if((G__85776 == null)){
return null;
} else {
return nextjournal.clojure_mode.node.balanced_range.cljs$core$IFn$_invoke$arity$2(state,G__85776);
}
})();
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return range;
}
})()], null);
} else {
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"range","range",1639692286),(function (){var or__4223__auto__ = (function (){var G__85777 = nextjournal.clojure_mode.extensions.selection_history.grow_1(state,from,to);
if((G__85777 == null)){
return null;
} else {
return nextjournal.clojure_mode.node.range(G__85777);
}
})();
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return range;
}
})()], null);
}
}));
});
nextjournal.clojure_mode.extensions.selection_history.selection_return_STAR_ = (function nextjournal$clojure_mode$extensions$selection_history$selection_return_STAR_(state){
var temp__5751__auto__ = new cljs.core.Keyword(null,"selection","selection",975998651).cljs$core$IFn$_invoke$arity$1(cljs.core.second(nextjournal.clojure_mode.extensions.selection_history.stack(state)));
if(cljs.core.truth_(temp__5751__auto__)){
var selection = temp__5751__auto__;
return state.update(({"selection": selection, "annotations": nextjournal.clojure_mode.extensions.selection_history.event_annotation}));
} else {
return nextjournal.clojure_mode.util.update_ranges.cljs$core$IFn$_invoke$arity$3(state,({"annotations": nextjournal.clojure_mode.extensions.selection_history.event_annotation}),(function (range){
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),range.from], null);
}));
}
});

//# sourceMappingURL=nextjournal.clojure_mode.extensions.selection_history.js.map
