import "./cljs_env.js";
goog.provide('clojure_eval.sci');
var module$node_modules$$codemirror$view$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$view$dist$index_cjs", {});
if((typeof clojure_eval !== 'undefined') && (typeof clojure_eval.sci !== 'undefined') && (typeof clojure_eval.sci._BANG_viewer !== 'undefined')){
} else {
clojure_eval.sci._BANG_viewer = cljs.core.atom.cljs$core$IFn$_invoke$arity$1("");
}
if((typeof clojure_eval !== 'undefined') && (typeof clojure_eval.sci !== 'undefined') && (typeof clojure_eval.sci.last_result !== 'undefined')){
} else {
clojure_eval.sci.last_result = cljs.core.atom.cljs$core$IFn$_invoke$arity$1("");
}
if((typeof clojure_eval !== 'undefined') && (typeof clojure_eval.sci !== 'undefined') && (typeof clojure_eval.sci.context !== 'undefined')){
} else {
clojure_eval.sci.context = sci.core.init(new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"classes","classes",2037804510),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Symbol(null,"js","js",-886355190,null),goog.global,new cljs.core.Keyword(null,"allow","allow",-1857325745),new cljs.core.Keyword(null,"all","all",892129742)], null)], null));
}
clojure_eval.sci.eval_string = (function clojure_eval$sci$eval_string(var_args){
var G__86250 = arguments.length;
switch (G__86250) {
case 1:
return clojure_eval.sci.eval_string.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return clojure_eval.sci.eval_string.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(clojure_eval.sci.eval_string.cljs$core$IFn$_invoke$arity$1 = (function (source){
return clojure_eval.sci.eval_string.cljs$core$IFn$_invoke$arity$2(clojure_eval.sci.context,source);
}));

(clojure_eval.sci.eval_string.cljs$core$IFn$_invoke$arity$2 = (function (ctx,source){
var temp__5757__auto__ = cljs.core.not_empty(clojure.string.trim(source));
if((temp__5757__auto__ == null)){
return null;
} else {
var code = temp__5757__auto__;
try{return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"result","result",1415092211),sci.core.eval_string_STAR_(ctx,code)], null);
}catch (e86257){if((e86257 instanceof Error)){
var e = e86257;
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"error","error",-978969032),cljs.core.str.cljs$core$IFn$_invoke$arity$1(e.message)], null);
} else {
throw e86257;

}
}}
}));

(clojure_eval.sci.eval_string.cljs$lang$maxFixedArity = 2);

if((typeof clojure_eval !== 'undefined') && (typeof clojure_eval.sci !== 'undefined') && (typeof clojure_eval.sci.eval_tail !== 'undefined')){
} else {
clojure_eval.sci.eval_tail = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null);
}
clojure_eval.sci.update_editor_BANG_ = (function clojure_eval$sci$update_editor_BANG_(text,cursor_pos){
var end = cljs.core.count((function (){var G__86269 = cljs.core.deref(clojure_eval.sci._BANG_viewer);
var G__86269__$1 = (((G__86269 == null))?null:G__86269.state);
var G__86269__$2 = (((G__86269__$1 == null))?null:G__86269__$1.doc);
if((G__86269__$2 == null)){
return null;
} else {
return cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__86269__$2);
}
})());
return cljs.core.deref(clojure_eval.sci._BANG_viewer).dispatch(({"changes": ({"from": (0), "to": end, "insert": text}), "selection": ({"anchor": cursor_pos, "head": cursor_pos})}));
});
clojure_eval.sci.eval_at_cursor = (function clojure_eval$sci$eval_at_cursor(on_result,p__86282){
var map__86284 = p__86282;
var map__86284__$1 = (((((!((map__86284 == null))))?(((((map__86284.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__86284.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__86284):map__86284);
var state = (function (){var obj86286 = map__86284__$1;
var k86287 = "state";
if((function (){var obj86290 = obj86286;
return (((!((obj86290 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86287,obj86290)));
})()){
return (obj86286[k86287]);
} else {
return undefined;
}
})();
var cursor_pos_86393 = (function (){var G__86292 = cljs.core.deref(clojure_eval.sci._BANG_viewer);
var G__86292__$1 = (((G__86292 == null))?null:G__86292.state);
var G__86292__$2 = (((G__86292__$1 == null))?null:G__86292__$1.selection);
var G__86292__$3 = (((G__86292__$2 == null))?null:G__86292__$2.main);
if((G__86292__$3 == null)){
return null;
} else {
return G__86292__$3.head;
}
})();
var code_86394 = cljs.core.first(clojure.string.split.cljs$core$IFn$_invoke$arity$2(cljs.core.str.cljs$core$IFn$_invoke$arity$1((function (){var G__86321 = cljs.core.deref(clojure_eval.sci._BANG_viewer);
var G__86321__$1 = (((G__86321 == null))?null:G__86321.state);
var G__86321__$2 = (((G__86321__$1 == null))?null:G__86321__$1.doc);
if((G__86321__$2 == null)){
return null;
} else {
return cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__86321__$2);
}
})()),/ => /));
var G__86322_86395 = nextjournal.clojure_mode.extensions.eval_region.cursor_node_string(state);
var G__86322_86396__$1 = (((G__86322_86395 == null))?null:clojure_eval.sci.eval_string.cljs$core$IFn$_invoke$arity$1(G__86322_86395));
if((G__86322_86396__$1 == null)){
} else {
(on_result.cljs$core$IFn$_invoke$arity$1 ? on_result.cljs$core$IFn$_invoke$arity$1(G__86322_86396__$1) : on_result.call(null,G__86322_86396__$1));
}

clojure_eval.sci.update_editor_BANG_([cljs.core.subs.cljs$core$IFn$_invoke$arity$3(code_86394,(0),cursor_pos_86393),((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("",new cljs.core.Keyword(null,"result","result",1415092211).cljs$core$IFn$_invoke$arity$1(cljs.core.deref(clojure_eval.sci.last_result))))?null:" => "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"result","result",1415092211).cljs$core$IFn$_invoke$arity$1(cljs.core.deref(clojure_eval.sci.last_result))),cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.reset_BANG_(clojure_eval.sci.eval_tail,cljs.core.subs.cljs$core$IFn$_invoke$arity$3(code_86394,cursor_pos_86393,cljs.core.count(code_86394))))].join(''),cursor_pos_86393);

cljs.core.deref(clojure_eval.sci._BANG_viewer).dispatch(({"selection": ({"anchor": cursor_pos_86393, "head": cursor_pos_86393})}));

return true;
});
clojure_eval.sci.eval_top_level = (function clojure_eval$sci$eval_top_level(on_result,p__86325){
var map__86326 = p__86325;
var map__86326__$1 = (((((!((map__86326 == null))))?(((((map__86326.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__86326.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__86326):map__86326);
var state = (function (){var obj86331 = map__86326__$1;
var k86332 = "state";
if((function (){var obj86333 = obj86331;
return (((!((obj86333 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86332,obj86333)));
})()){
return (obj86331[k86332]);
} else {
return undefined;
}
})();
var G__86336_86397 = nextjournal.clojure_mode.extensions.eval_region.top_level_string(state);
var G__86336_86398__$1 = (((G__86336_86397 == null))?null:clojure_eval.sci.eval_string.cljs$core$IFn$_invoke$arity$1(G__86336_86397));
if((G__86336_86398__$1 == null)){
} else {
(on_result.cljs$core$IFn$_invoke$arity$1 ? on_result.cljs$core$IFn$_invoke$arity$1(G__86336_86398__$1) : on_result.call(null,G__86336_86398__$1));
}

return true;
});
clojure_eval.sci.eval_cell = (function clojure_eval$sci$eval_cell(on_result,p__86338){
var map__86340 = p__86338;
var map__86340__$1 = (((((!((map__86340 == null))))?(((((map__86340.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__86340.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__86340):map__86340);
var state = (function (){var obj86344 = map__86340__$1;
var k86345 = "state";
if((function (){var obj86346 = obj86344;
return (((!((obj86346 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k86345,obj86346)));
})()){
return (obj86344[k86345]);
} else {
return undefined;
}
})();
var G__86350_86399 = clojure_eval.sci.eval_string.cljs$core$IFn$_invoke$arity$1(["(do ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(state.doc)," )"].join(''));
(on_result.cljs$core$IFn$_invoke$arity$1 ? on_result.cljs$core$IFn$_invoke$arity$1(G__86350_86399) : on_result.call(null,G__86350_86399));

return true;
});
clojure_eval.sci.clear_eval = (function clojure_eval$sci$clear_eval(){
if(cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2("",cljs.core.deref(clojure_eval.sci.last_result))){
cljs.core.reset_BANG_(clojure_eval.sci.last_result,"");

var code = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.first(clojure.string.split.cljs$core$IFn$_invoke$arity$2(cljs.core.str.cljs$core$IFn$_invoke$arity$1((function (){var G__86360 = cljs.core.deref(clojure_eval.sci._BANG_viewer);
var G__86360__$1 = (((G__86360 == null))?null:G__86360.state);
var G__86360__$2 = (((G__86360__$1 == null))?null:G__86360__$1.doc);
if((G__86360__$2 == null)){
return null;
} else {
return cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__86360__$2);
}
})()),/ => /))),cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(clojure_eval.sci.eval_tail))].join('');
var cursor_pos = (function (){var G__86361 = cljs.core.deref(clojure_eval.sci._BANG_viewer);
var G__86361__$1 = (((G__86361 == null))?null:G__86361.state);
var G__86361__$2 = (((G__86361__$1 == null))?null:G__86361__$1.selection);
var G__86361__$3 = (((G__86361__$2 == null))?null:G__86361__$2.main);
if((G__86361__$3 == null)){
return null;
} else {
return G__86361__$3.head;
}
})();
return clojure_eval.sci.update_editor_BANG_(code,(function (){var x__4309__auto__ = cursor_pos;
var y__4310__auto__ = ((code).length);
return ((x__4309__auto__ < y__4310__auto__) ? x__4309__auto__ : y__4310__auto__);
})());
} else {
return null;
}
});
clojure_eval.sci.extension = (function clojure_eval$sci$extension(){
return module$node_modules$$codemirror$view$dist$index_cjs.keymap.of([({"key":"Alt-Enter","run":cljs.core.partial.cljs$core$IFn$_invoke$arity$2(clojure_eval.sci.eval_cell,(function (result){
return cljs.core.reset_BANG_(clojure_eval.sci.last_result,result);
}))}),({"key":"Mod-Enter","run":cljs.core.partial.cljs$core$IFn$_invoke$arity$2(clojure_eval.sci.eval_top_level,(function (result){
return cljs.core.reset_BANG_(clojure_eval.sci.last_result,result);
}))}),({"key":"Shift-Enter","run":cljs.core.partial.cljs$core$IFn$_invoke$arity$2(clojure_eval.sci.eval_at_cursor,(function (result){
return cljs.core.reset_BANG_(clojure_eval.sci.last_result,result);
}))}),({"key":"Escape","run":clojure_eval.sci.clear_eval}),({"key":"ArrowLeft","run":clojure_eval.sci.clear_eval}),({"key":"ArrowRight","run":clojure_eval.sci.clear_eval})]);
});

//# sourceMappingURL=clojure_eval.sci.js.map
