import "./cljs_env.js";
goog.provide('nextjournal.clojure_mode.extensions.eval_region');
var module$node_modules$$codemirror$state$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$state$dist$index_cjs", {});
var module$node_modules$$codemirror$view$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$view$dist$index_cjs", {});
var module$node_modules$w3c_keyname$index_cjs=shadow.js.require("module$node_modules$w3c_keyname$index_cjs", {});
/**
 * Returns node or its highest ancestor that starts or ends at the cursor position.
 */
nextjournal.clojure_mode.extensions.eval_region.uppermost_edge_here = (function nextjournal$clojure_mode$extensions$eval_region$uppermost_edge_here(pos,node){
var or__4223__auto__ = cljs.core.last(cljs.core.take_while.cljs$core$IFn$_invoke$arity$2(cljs.core.every_pred.cljs$core$IFn$_invoke$arity$2(cljs.core.complement(nextjournal.clojure_mode.node.top_QMARK_),(function (p1__80825_SHARP_){
return ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$variadic(pos,nextjournal.clojure_mode.node.end(p1__80825_SHARP_),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([nextjournal.clojure_mode.node.end(node)], 0))) || (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$variadic(pos,nextjournal.clojure_mode.node.start(p1__80825_SHARP_),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([nextjournal.clojure_mode.node.start(node)], 0))));
})),cljs.core.iterate(nextjournal.clojure_mode.node.up,node)));
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return node;
}
});
nextjournal.clojure_mode.extensions.eval_region.main_selection = (function nextjournal$clojure_mode$extensions$eval_region$main_selection(state){
var obj80830 = (function (){var obj80828 = (function (){var parent__49521__auto__ = (state["selection"]);
var f__49522__auto__ = (parent__49521__auto__["asSingle"]);
return f__49522__auto__.call(parent__49521__auto__);
})();
var k80829 = "ranges";
if((function (){var obj80833 = obj80828;
return (((!((obj80833 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80829,obj80833)));
})()){
return (obj80828[k80829]);
} else {
return undefined;
}
})();
var k80831 = (0);
if((function (){var obj80835 = obj80830;
return (((!((obj80835 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80831,obj80835)));
})()){
return (obj80830[k80831]);
} else {
return undefined;
}
});
nextjournal.clojure_mode.extensions.eval_region.node_at_cursor = (function nextjournal$clojure_mode$extensions$eval_region$node_at_cursor(var_args){
var G__80840 = arguments.length;
switch (G__80840) {
case 1:
return nextjournal.clojure_mode.extensions.eval_region.node_at_cursor.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return nextjournal.clojure_mode.extensions.eval_region.node_at_cursor.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(nextjournal.clojure_mode.extensions.eval_region.node_at_cursor.cljs$core$IFn$_invoke$arity$1 = (function (state){
return nextjournal.clojure_mode.extensions.eval_region.node_at_cursor.cljs$core$IFn$_invoke$arity$2(state,(function (){var obj80842 = nextjournal.clojure_mode.extensions.eval_region.main_selection(state);
var k80843 = "from";
if((function (){var obj80844 = obj80842;
return (((!((obj80844 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80843,obj80844)));
})()){
return (obj80842[k80843]);
} else {
return undefined;
}
})());
}));

(nextjournal.clojure_mode.extensions.eval_region.node_at_cursor.cljs$core$IFn$_invoke$arity$2 = (function (state,from){
var G__80845 = nextjournal.clojure_mode.node.nearest_touching(state,from,(-1));
var G__80845__$1 = (((G__80845 == null))?null:(function (p1__80837_SHARP_){
if(((nextjournal.clojure_mode.node.terminal_type_QMARK_(nextjournal.clojure_mode.node.type(p1__80837_SHARP_))) || ((((nextjournal.clojure_mode.node.start(p1__80837_SHARP_) <= from)) || ((nextjournal.clojure_mode.node.end(p1__80837_SHARP_) <= from)))))){
var G__80847 = p1__80837_SHARP_;
if(((nextjournal.clojure_mode.node.top_QMARK_(p1__80837_SHARP_)) || ((((!(nextjournal.clojure_mode.node.terminal_type_QMARK_(nextjournal.clojure_mode.node.type(p1__80837_SHARP_))))) && ((((nextjournal.clojure_mode.node.start(p1__80837_SHARP_) < from)) && ((from < nextjournal.clojure_mode.node.end(p1__80837_SHARP_))))))))){
return cljs.core.first(nextjournal.clojure_mode.node.children.cljs$core$IFn$_invoke$arity$3(G__80847,from,(-1)));
} else {
return G__80847;
}
} else {
return null;
}
})(G__80845));
var G__80845__$2 = (((G__80845__$1 == null))?null:nextjournal.clojure_mode.extensions.eval_region.uppermost_edge_here(from,G__80845__$1));
if((G__80845__$2 == null)){
return null;
} else {
return nextjournal.clojure_mode.node.balanced_range.cljs$core$IFn$_invoke$arity$2(state,G__80845__$2);
}
}));

(nextjournal.clojure_mode.extensions.eval_region.node_at_cursor.cljs$lang$maxFixedArity = 2);

nextjournal.clojure_mode.extensions.eval_region.top_level_node = (function nextjournal$clojure_mode$extensions$eval_region$top_level_node(state){
return cljs.core.last(cljs.core.take_while.cljs$core$IFn$_invoke$arity$2(cljs.core.every_pred.cljs$core$IFn$_invoke$arity$2(cljs.core.identity,cljs.core.complement(nextjournal.clojure_mode.node.top_QMARK_)),cljs.core.iterate(nextjournal.clojure_mode.node.up,nextjournal.clojure_mode.node.nearest_touching(state,(function (){var obj80853 = nextjournal.clojure_mode.extensions.eval_region.main_selection(state);
var k80854 = "from";
if((function (){var obj80855 = obj80853;
return (((!((obj80855 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80854,obj80855)));
})()){
return (obj80853[k80854]);
} else {
return undefined;
}
})(),(-1)))));
});
if((typeof nextjournal !== 'undefined') && (typeof nextjournal.clojure_mode !== 'undefined') && (typeof nextjournal.clojure_mode.extensions !== 'undefined') && (typeof nextjournal.clojure_mode.extensions.eval_region !== 'undefined') && (typeof nextjournal.clojure_mode.extensions.eval_region.modifier_effect !== 'undefined')){
} else {
nextjournal.clojure_mode.extensions.eval_region.modifier_effect = module$node_modules$$codemirror$state$dist$index_cjs.StateEffect.define();
}
if((typeof nextjournal !== 'undefined') && (typeof nextjournal.clojure_mode !== 'undefined') && (typeof nextjournal.clojure_mode.extensions !== 'undefined') && (typeof nextjournal.clojure_mode.extensions.eval_region !== 'undefined') && (typeof nextjournal.clojure_mode.extensions.eval_region.modifier_field !== 'undefined')){
} else {
nextjournal.clojure_mode.extensions.eval_region.modifier_field = module$node_modules$$codemirror$state$dist$index_cjs.StateField.define(({"create":cljs.core.constantly(cljs.core.PersistentArrayMap.EMPTY),"update":(function (value,tr){
var or__4223__auto__ = (function (){var G__80857 = cljs.core.first(cljs.core.filter.cljs$core$IFn$_invoke$arity$2((function (p1__80856_SHARP_){
return p1__80856_SHARP_.is(nextjournal.clojure_mode.extensions.eval_region.modifier_effect);
}),tr.effects));
if((G__80857 == null)){
return null;
} else {
var obj80858 = G__80857;
var k80859 = "value";
if((function (){var obj80860 = obj80858;
return (((!((obj80860 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80859,obj80860)));
})()){
return (obj80858[k80859]);
} else {
return undefined;
}
}
})();
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return value;
}
})}));
}
nextjournal.clojure_mode.extensions.eval_region.get_modifier_field = (function nextjournal$clojure_mode$extensions$eval_region$get_modifier_field(state){
return state.field(nextjournal.clojure_mode.extensions.eval_region.modifier_field);
});
nextjournal.clojure_mode.extensions.eval_region.set_modifier_field_BANG_ = (function nextjournal$clojure_mode$extensions$eval_region$set_modifier_field_BANG_(p__80862,value){
var map__80863 = p__80862;
var map__80863__$1 = (((((!((map__80863 == null))))?(((((map__80863.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80863.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80863):map__80863);
var view = map__80863__$1;
var dispatch = (function (){var obj80865 = map__80863__$1;
var k80866 = "dispatch";
if((function (){var obj80867 = obj80865;
return (((!((obj80867 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80866,obj80867)));
})()){
return (obj80865[k80866]);
} else {
return undefined;
}
})();
var state = (function (){var obj80868 = map__80863__$1;
var k80869 = "state";
if((function (){var obj80870 = obj80868;
return (((!((obj80870 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80869,obj80870)));
})()){
return (obj80868[k80869]);
} else {
return undefined;
}
})();
var G__80871 = ({"effects": nextjournal.clojure_mode.extensions.eval_region.modifier_effect.of(value)});
return (dispatch.cljs$core$IFn$_invoke$arity$1 ? dispatch.cljs$core$IFn$_invoke$arity$1(G__80871) : dispatch.call(null,G__80871));
});
nextjournal.clojure_mode.extensions.eval_region.mark = (function nextjournal$clojure_mode$extensions$eval_region$mark(spec,p__80873){
var map__80874 = p__80873;
var map__80874__$1 = (((((!((map__80874 == null))))?(((((map__80874.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80874.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80874):map__80874);
var from = (function (){var obj80876 = map__80874__$1;
var k80877 = "from";
if((function (){var obj80878 = obj80876;
return (((!((obj80878 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80877,obj80878)));
})()){
return (obj80876[k80877]);
} else {
return undefined;
}
})();
var to = (function (){var obj80879 = map__80874__$1;
var k80880 = "to";
if((function (){var obj80881 = obj80879;
return (((!((obj80881 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80880,obj80881)));
})()){
return (obj80879[k80880]);
} else {
return undefined;
}
})();
return module$node_modules$$codemirror$view$dist$index_cjs.Decoration.mark(spec).range(from,to);
});
nextjournal.clojure_mode.extensions.eval_region.single_mark = (function nextjournal$clojure_mode$extensions$eval_region$single_mark(spec,range){
return module$node_modules$$codemirror$view$dist$index_cjs.Decoration.set([nextjournal.clojure_mode.extensions.eval_region.mark(spec,range)]);
});
if((typeof nextjournal !== 'undefined') && (typeof nextjournal.clojure_mode !== 'undefined') && (typeof nextjournal.clojure_mode.extensions !== 'undefined') && (typeof nextjournal.clojure_mode.extensions.eval_region !== 'undefined') && (typeof nextjournal.clojure_mode.extensions.eval_region.mark_spec !== 'undefined')){
} else {
nextjournal.clojure_mode.extensions.eval_region.mark_spec = ({"attributes":({"style":"background-color: rgba(0, 243, 255, 0.14);"})});
}
if((typeof nextjournal !== 'undefined') && (typeof nextjournal.clojure_mode !== 'undefined') && (typeof nextjournal.clojure_mode.extensions !== 'undefined') && (typeof nextjournal.clojure_mode.extensions.eval_region !== 'undefined') && (typeof nextjournal.clojure_mode.extensions.eval_region.mark_spec_highlight !== 'undefined')){
} else {
nextjournal.clojure_mode.extensions.eval_region.mark_spec_highlight = ({"attributes":({"style":"background-color: rgba(0, 243, 255, 0.35);"})});
}
nextjournal.clojure_mode.extensions.eval_region.cursor_range = (function nextjournal$clojure_mode$extensions$eval_region$cursor_range(state){
if(cljs.core.truth_(state.selection.main.empty)){
return nextjournal.clojure_mode.extensions.eval_region.node_at_cursor.cljs$core$IFn$_invoke$arity$1(state);
} else {
return state.selection.main;
}
});
if((typeof nextjournal !== 'undefined') && (typeof nextjournal.clojure_mode !== 'undefined') && (typeof nextjournal.clojure_mode.extensions !== 'undefined') && (typeof nextjournal.clojure_mode.extensions.eval_region !== 'undefined') && (typeof nextjournal.clojure_mode.extensions.eval_region.region_field !== 'undefined')){
} else {
nextjournal.clojure_mode.extensions.eval_region.region_field = module$node_modules$$codemirror$state$dist$index_cjs.StateField.define(({"create":cljs.core.constantly(module$node_modules$$codemirror$view$dist$index_cjs.Decoration.none),"update":(function (_value,p__80888){
var map__80890 = p__80888;
var map__80890__$1 = (((((!((map__80890 == null))))?(((((map__80890.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80890.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80890):map__80890);
var state = (function (){var obj80893 = map__80890__$1;
var k80894 = "state";
if((function (){var obj80895 = obj80893;
return (((!((obj80895 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80894,obj80895)));
})()){
return (obj80893[k80894]);
} else {
return undefined;
}
})();
var map__80898 = nextjournal.clojure_mode.extensions.eval_region.get_modifier_field(state);
var map__80898__$1 = cljs.core.__destructure_map(map__80898);
var Alt = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__80898__$1,"Alt");
var Shift = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__80898__$1,"Shift");
var Enter = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__80898__$1,"Enter");
var spec = (cljs.core.truth_(Enter)?nextjournal.clojure_mode.extensions.eval_region.mark_spec_highlight:nextjournal.clojure_mode.extensions.eval_region.mark_spec);
var temp__5751__auto__ = (cljs.core.truth_((function (){var and__4221__auto__ = Alt;
if(cljs.core.truth_(and__4221__auto__)){
return Shift;
} else {
return and__4221__auto__;
}
})())?nextjournal.clojure_mode.extensions.eval_region.top_level_node(state):(cljs.core.truth_(Alt)?(function (){var or__4223__auto__ = nextjournal.clojure_mode.util.guard(nextjournal.clojure_mode.extensions.eval_region.main_selection(state),(function (p1__80886_SHARP_){
return cljs.core.not((function (){var obj80901 = p1__80886_SHARP_;
var k80902 = "empty";
if((function (){var obj80903 = obj80901;
return (((!((obj80903 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80902,obj80903)));
})()){
return (obj80901[k80902]);
} else {
return undefined;
}
})());
}));
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return nextjournal.clojure_mode.extensions.eval_region.cursor_range(state);
}
})():null));
if(cljs.core.truth_(temp__5751__auto__)){
var range = temp__5751__auto__;
return nextjournal.clojure_mode.extensions.eval_region.single_mark(spec,range);
} else {
return module$node_modules$$codemirror$view$dist$index_cjs.Decoration.none;
}
})}));
}
nextjournal.clojure_mode.extensions.eval_region.get_region_field = (function nextjournal$clojure_mode$extensions$eval_region$get_region_field(state){
return state.field(nextjournal.clojure_mode.extensions.eval_region.region_field);
});
nextjournal.clojure_mode.extensions.eval_region.current_range = (function nextjournal$clojure_mode$extensions$eval_region$current_range(state){
var or__4223__auto__ = (function (){var G__80908 = nextjournal.clojure_mode.extensions.eval_region.get_region_field(state);
var G__80908__$1 = (((G__80908 == null))?null:(function (){var obj__49512__auto__ = G__80908;
var f__49513__auto__ = (obj__49512__auto__["iter"]);
return f__49513__auto__.call(obj__49512__auto__);
})());
if((G__80908__$1 == null)){
return null;
} else {
return nextjournal.clojure_mode.util.guard(G__80908__$1,(function (p1__80907_SHARP_){
var obj80910 = p1__80907_SHARP_;
var k80911 = "value";
if((function (){var obj80912 = obj80910;
return (((!((obj80912 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80911,obj80912)));
})()){
return (obj80910[k80911]);
} else {
return undefined;
}
}));
}
})();
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return state.selection.main;
}
});
/**
 * Maintains modifier-state-field, containing a map of {<modifier> true}, including Enter.
 */
nextjournal.clojure_mode.extensions.eval_region.modifier_extension = (function nextjournal$clojure_mode$extensions$eval_region$modifier_extension(modifier){
var handle_enter = (function nextjournal$clojure_mode$extensions$eval_region$modifier_extension_$_handle_enter(p__80916){
var map__80917 = p__80916;
var map__80917__$1 = (((((!((map__80917 == null))))?(((((map__80917.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80917.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80917):map__80917);
var view = map__80917__$1;
var state = (function (){var obj80919 = map__80917__$1;
var k80920 = "state";
if((function (){var obj80922 = obj80919;
return (((!((obj80922 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80920,obj80922)));
})()){
return (obj80919[k80920]);
} else {
return undefined;
}
})();
nextjournal.clojure_mode.extensions.eval_region.set_modifier_field_BANG_(view,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(nextjournal.clojure_mode.extensions.eval_region.get_modifier_field(state),"Enter",true));

return null;
});
var handle_key_event = (function (p__80923,p__80924){
var map__80926 = p__80923;
var map__80926__$1 = (((((!((map__80926 == null))))?(((((map__80926.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80926.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80926):map__80926);
var event = map__80926__$1;
var altKey = (function (){var obj80929 = map__80926__$1;
var k80930 = "altKey";
if((function (){var obj80931 = obj80929;
return (((!((obj80931 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80930,obj80931)));
})()){
return (obj80929[k80930]);
} else {
return undefined;
}
})();
var shiftKey = (function (){var obj80932 = map__80926__$1;
var k80933 = "shiftKey";
if((function (){var obj80934 = obj80932;
return (((!((obj80934 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80933,obj80934)));
})()){
return (obj80932[k80933]);
} else {
return undefined;
}
})();
var metaKey = (function (){var obj80935 = map__80926__$1;
var k80936 = "metaKey";
if((function (){var obj80937 = obj80935;
return (((!((obj80937 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80936,obj80937)));
})()){
return (obj80935[k80936]);
} else {
return undefined;
}
})();
var controlKey = (function (){var obj80938 = map__80926__$1;
var k80939 = "controlKey";
if((function (){var obj80940 = obj80938;
return (((!((obj80940 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80939,obj80940)));
})()){
return (obj80938[k80939]);
} else {
return undefined;
}
})();
var type = (function (){var obj80941 = map__80926__$1;
var k80942 = "type";
if((function (){var obj80943 = obj80941;
return (((!((obj80943 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80942,obj80943)));
})()){
return (obj80941[k80942]);
} else {
return undefined;
}
})();
var map__80944 = p__80924;
var map__80944__$1 = (((((!((map__80944 == null))))?(((((map__80944.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80944.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80944):map__80944);
var view = map__80944__$1;
var state = (function (){var obj80946 = map__80944__$1;
var k80947 = "state";
if((function (){var obj80948 = obj80946;
return (((!((obj80948 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80947,obj80948)));
})()){
return (obj80946[k80947]);
} else {
return undefined;
}
})();
var prev = nextjournal.clojure_mode.extensions.eval_region.get_modifier_field(state);
var next = (function (){var G__80949 = cljs.core.PersistentArrayMap.EMPTY;
var G__80949__$1 = (cljs.core.truth_(altKey)?cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__80949,"Alt",true):G__80949);
var G__80949__$2 = (cljs.core.truth_(shiftKey)?cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__80949__$1,"Shift",true):G__80949__$1);
var G__80949__$3 = (cljs.core.truth_(metaKey)?cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__80949__$2,"Meta",true):G__80949__$2);
var G__80949__$4 = (cljs.core.truth_(controlKey)?cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__80949__$3,"Control",true):G__80949__$3);
if(((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("keydown",type)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("Enter",module$node_modules$w3c_keyname$index_cjs.keyName(event))))){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__80949__$4,"Enter",true);
} else {
return G__80949__$4;
}
})();
if(cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(prev,next)){
return nextjournal.clojure_mode.extensions.eval_region.set_modifier_field_BANG_(view,next);
} else {
return null;
}
});
var handle_backspace = (function (p__80952){
var map__80953 = p__80952;
var map__80953__$1 = (((((!((map__80953 == null))))?(((((map__80953.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80953.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80953):map__80953);
var view = map__80953__$1;
var state = (function (){var obj80955 = map__80953__$1;
var k80956 = "state";
if((function (){var obj80957 = obj80955;
return (((!((obj80957 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80956,obj80957)));
})()){
return (obj80955[k80956]);
} else {
return undefined;
}
})();
var dispatch = (function (){var obj80958 = map__80953__$1;
var k80959 = "dispatch";
if((function (){var obj80960 = obj80958;
return (((!((obj80960 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80959,obj80960)));
})()){
return (obj80958[k80959]);
} else {
return undefined;
}
})();
var map__80961 = nextjournal.clojure_mode.extensions.eval_region.current_range(state);
var map__80961__$1 = (((((!((map__80961 == null))))?(((((map__80961.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80961.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80961):map__80961);
var from = (function (){var obj80963 = map__80961__$1;
var k80964 = "from";
if((function (){var obj80965 = obj80963;
return (((!((obj80965 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80964,obj80965)));
})()){
return (obj80963[k80964]);
} else {
return undefined;
}
})();
var to = (function (){var obj80969 = map__80961__$1;
var k80970 = "to";
if((function (){var obj80971 = obj80969;
return (((!((obj80971 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80970,obj80971)));
})()){
return (obj80969[k80970]);
} else {
return undefined;
}
})();
if(cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(from,to)){
var G__80972_81019 = ({"changes":({"from":from,"to":to,"insert":""}),"annotations":nextjournal.clojure_mode.util.user_event_annotation("delete")});
(dispatch.cljs$core$IFn$_invoke$arity$1 ? dispatch.cljs$core$IFn$_invoke$arity$1(G__80972_81019) : dispatch.call(null,G__80972_81019));
} else {
}

return true;
});
return [nextjournal.clojure_mode.extensions.eval_region.modifier_field,module$node_modules$$codemirror$view$dist$index_cjs.keymap.of([({"key":[cljs.core.str.cljs$core$IFn$_invoke$arity$1(modifier),"-Enter"].join(''),"shift":handle_enter,"run":handle_enter}),({"key":[cljs.core.str.cljs$core$IFn$_invoke$arity$1(modifier),"-Backspace"].join(''),"run":handle_backspace,"shift":handle_backspace})]),module$node_modules$$codemirror$view$dist$index_cjs.EditorView.domEventHandlers(({"keydown": handle_key_event, "keyup": handle_key_event}))];
});
nextjournal.clojure_mode.extensions.eval_region.extension = (function nextjournal$clojure_mode$extensions$eval_region$extension(p__80973){
var map__80974 = p__80973;
var map__80974__$1 = cljs.core.__destructure_map(map__80974);
var modifier = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__80974__$1,new cljs.core.Keyword(null,"modifier","modifier",1634442788),"Alt");
return [nextjournal.clojure_mode.extensions.eval_region.modifier_extension(modifier),nextjournal.clojure_mode.extensions.eval_region.region_field,module$node_modules$$codemirror$view$dist$index_cjs.EditorView.decorations.from(nextjournal.clojure_mode.extensions.eval_region.region_field)];
});
nextjournal.clojure_mode.extensions.eval_region.cursor_node_string = (function nextjournal$clojure_mode$extensions$eval_region$cursor_node_string(state){
return nextjournal.clojure_mode.util.guard((function (){var G__80976 = nextjournal.clojure_mode.extensions.eval_region.node_at_cursor.cljs$core$IFn$_invoke$arity$1(state);
if((G__80976 == null)){
return null;
} else {
return nextjournal.clojure_mode.util.range_str(state,G__80976);
}
})(),cljs.core.complement(clojure.string.blank_QMARK_));
});
nextjournal.clojure_mode.extensions.eval_region.top_level_string = (function nextjournal$clojure_mode$extensions$eval_region$top_level_string(state){
return nextjournal.clojure_mode.util.guard((function (){var G__80979 = nextjournal.clojure_mode.extensions.eval_region.top_level_node(state);
if((G__80979 == null)){
return null;
} else {
return nextjournal.clojure_mode.util.range_str(state,G__80979);
}
})(),cljs.core.complement(clojure.string.blank_QMARK_));
});

//# sourceMappingURL=nextjournal.clojure_mode.extensions.eval_region.js.map
