import "./cljs_env.js";
goog.provide('nextjournal.clojure_mode.extensions.formatting');
var module$node_modules$$codemirror$language$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$language$dist$index_cjs", {});
var module$node_modules$$codemirror$state$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$state$dist$index_cjs", {});
var module$node_modules$$codemirror$view$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$view$dist$index_cjs", {});
var module$node_modules$$codemirror$commands$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$commands$dist$index_cjs", {});
nextjournal.clojure_mode.extensions.formatting.spaces = (function nextjournal$clojure_mode$extensions$formatting$spaces(state,n){
return module$node_modules$$codemirror$language$dist$index_cjs.indentString(state,n);
});
nextjournal.clojure_mode.extensions.formatting.indent_node_props = (function nextjournal$clojure_mode$extensions$formatting$indent_node_props(p__85505){
var map__85507 = p__85505;
var map__85507__$1 = (((((!((map__85507 == null))))?(((((map__85507.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__85507.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__85507):map__85507);
var type = map__85507__$1;
var type_name = (function (){var obj85509 = map__85507__$1;
var k85510 = "name";
if((function (){var obj85511 = obj85509;
return (((!((obj85511 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85510,obj85511)));
})()){
return (obj85509[k85510]);
} else {
return undefined;
}
})();
return (function (p__85513){
var map__85514 = p__85513;
var map__85514__$1 = (((((!((map__85514 == null))))?(((((map__85514.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__85514.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__85514):map__85514);
var context = map__85514__$1;
var pos = (function (){var obj85517 = map__85514__$1;
var k85518 = "pos";
if((function (){var obj85519 = obj85517;
return (((!((obj85519 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85518,obj85519)));
})()){
return (obj85517[k85518]);
} else {
return undefined;
}
})();
var unit = (function (){var obj85520 = map__85514__$1;
var k85521 = "unit";
if((function (){var obj85522 = obj85520;
return (((!((obj85522 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85521,obj85522)));
})()){
return (obj85520[k85521]);
} else {
return undefined;
}
})();
var node = (function (){var obj85523 = map__85514__$1;
var k85524 = "node";
if((function (){var obj85525 = obj85523;
return (((!((obj85525 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85524,obj85525)));
})()){
return (obj85523[k85524]);
} else {
return undefined;
}
})();
var state = (function (){var obj85527 = map__85514__$1;
var k85528 = "state";
if((function (){var obj85529 = obj85527;
return (((!((obj85529 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85528,obj85529)));
})()){
return (obj85527[k85528]);
} else {
return undefined;
}
})();
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("Program",type_name)){
return (0);
} else {
if(cljs.core.truth_(nextjournal.clojure_mode.node.coll_type_QMARK_(type))){
var G__85530 = context.column(nextjournal.clojure_mode.node.end(nextjournal.clojure_mode.node.down(node)));
if(cljs.core.truth_((function (){var and__4221__auto__ = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("List",type_name);
if(and__4221__auto__){
var G__85532 = (function (){var G__85533 = node;
var G__85533__$1 = (((G__85533 == null))?null:nextjournal.clojure_mode.node.down(G__85533));
var G__85533__$2 = (((G__85533__$1 == null))?null:nextjournal.clojure_mode.node.right(G__85533__$1));
if((G__85533__$2 == null)){
return null;
} else {
return nextjournal.clojure_mode.node.name(G__85533__$2);
}
})();
var fexpr__85531 = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, ["DefLike",null,"Operator",null], null), null);
return (fexpr__85531.cljs$core$IFn$_invoke$arity$1 ? fexpr__85531.cljs$core$IFn$_invoke$arity$1(G__85532) : fexpr__85531.call(null,G__85532));
} else {
return and__4221__auto__;
}
})())){
return (G__85530 + (1));
} else {
return G__85530;
}
} else {
return (-1);

}
}
});
});
nextjournal.clojure_mode.extensions.formatting.props = module$node_modules$$codemirror$language$dist$index_cjs.indentNodeProp.add(nextjournal.clojure_mode.extensions.formatting.indent_node_props);
nextjournal.clojure_mode.extensions.formatting.get_indentation = (function nextjournal$clojure_mode$extensions$formatting$get_indentation(context,pos){
return module$node_modules$$codemirror$language$dist$index_cjs.getIndentation(context.state,pos);
});
nextjournal.clojure_mode.extensions.formatting.make_indent_context = (function nextjournal$clojure_mode$extensions$formatting$make_indent_context(state){
return (new module$node_modules$$codemirror$language$dist$index_cjs.IndentContext(state));
});
nextjournal.clojure_mode.extensions.formatting.indent_all = (function nextjournal$clojure_mode$extensions$formatting$indent_all(state){
var context = nextjournal.clojure_mode.extensions.formatting.make_indent_context(state);
return nextjournal.clojure_mode.util.update_lines(state,(function (from,content,line_num){
var current_indent = (/^\s*/.exec(content)[(0)]).length;
var indent = nextjournal.clojure_mode.util.guard(nextjournal.clojure_mode.extensions.formatting.get_indentation(context,from),cljs.core.complement(cljs.core.neg_QMARK_));
if(cljs.core.truth_(indent)){
var G__85537 = cljs.core.compare(indent,current_indent);
switch (G__85537) {
case (0):
return null;

break;
case (1):
return ({"from": (from + current_indent), "insert": nextjournal.clojure_mode.extensions.formatting.spaces(state,(indent - current_indent))});

break;
case (-1):
return ({"from": (from + indent), "to": (from + current_indent)});

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__85537)].join('')));

}
} else {
return null;
}
}));
});
nextjournal.clojure_mode.extensions.formatting.expected_space = (function nextjournal$clojure_mode$extensions$formatting$expected_space(n1,n2){
if(((nextjournal.clojure_mode.node.start_edge_type_QMARK_(n1)) || (((nextjournal.clojure_mode.node.prefix_edge_type_QMARK_(n1)) || (((nextjournal.clojure_mode.node.end_edge_type_QMARK_(n2)) || (nextjournal.clojure_mode.node.same_edge_type_QMARK_(n2)))))))){
return (0);
} else {
return (1);
}
});
nextjournal.clojure_mode.extensions.formatting.space_changes = (function nextjournal$clojure_mode$extensions$formatting$space_changes(state,from,to){
var nodes = cljs.core.reverse(cljs.core.filter.cljs$core$IFn$_invoke$arity$2((function (p1__85540_SHARP_){
return (((((from <= nextjournal.clojure_mode.node.start(p1__85540_SHARP_))) && ((nextjournal.clojure_mode.node.start(p1__85540_SHARP_) <= to)))) || ((((from <= nextjournal.clojure_mode.node.end(p1__85540_SHARP_))) && ((nextjournal.clojure_mode.node.end(p1__85540_SHARP_) <= to)))));
}),nextjournal.clojure_mode.node.terminal_nodes(nextjournal.clojure_mode.node.tree.cljs$core$IFn$_invoke$arity$1(state),from,to)));
var trim_QMARK_ = (function (){var G__85542 = cljs.core.first(nodes);
var G__85542__$1 = (((G__85542 == null))?null:nextjournal.clojure_mode.node.end(G__85542));
if((G__85542__$1 == null)){
return null;
} else {
return (G__85542__$1 < to);
}
})();
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (out,p__85544){
var vec__85545 = p__85544;
var map__85549 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__85545,(0),null);
var map__85549__$1 = (((((!((map__85549 == null))))?(((((map__85549.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__85549.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__85549):map__85549);
var n2 = (function (){var obj85553 = map__85549__$1;
var k85554 = "type";
if((function (){var obj85555 = obj85553;
return (((!((obj85555 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85554,obj85555)));
})()){
return (obj85553[k85554]);
} else {
return undefined;
}
})();
var start2 = (function (){var obj85556 = map__85549__$1;
var k85557 = "from";
if((function (){var obj85558 = obj85556;
return (((!((obj85558 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85557,obj85558)));
})()){
return (obj85556[k85557]);
} else {
return undefined;
}
})();
var end2 = (function (){var obj85560 = map__85549__$1;
var k85561 = "to";
if((function (){var obj85562 = obj85560;
return (((!((obj85562 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85561,obj85562)));
})()){
return (obj85560[k85561]);
} else {
return undefined;
}
})();
var map__85550 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__85545,(1),null);
var map__85550__$1 = (((((!((map__85550 == null))))?(((((map__85550.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__85550.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__85550):map__85550);
var n1 = (function (){var obj85564 = map__85550__$1;
var k85565 = "type";
if((function (){var obj85567 = obj85564;
return (((!((obj85567 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85565,obj85567)));
})()){
return (obj85564[k85565]);
} else {
return undefined;
}
})();
var start1 = (function (){var obj85568 = map__85550__$1;
var k85569 = "from";
if((function (){var obj85570 = obj85568;
return (((!((obj85570 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85569,obj85570)));
})()){
return (obj85568[k85569]);
} else {
return undefined;
}
})();
var end1 = (function (){var obj85571 = map__85550__$1;
var k85572 = "to";
if((function (){var obj85573 = obj85571;
return (((!((obj85573 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85572,obj85573)));
})()){
return (obj85571[k85572]);
} else {
return undefined;
}
})();
var expected = nextjournal.clojure_mode.extensions.formatting.expected_space(n1,n2);
var actual = (start2 - end1);
var G__85575 = cljs.core.compare(actual,expected);
switch (G__85575) {
case (0):
return out;

break;
case (1):
var array85576 = out;
array85576.push(({"from": (((expected === (0)))?end1:(end1 + (1))), "to": start2}));

return array85576;

break;
case (-1):
var array85577 = out;
array85577.push(({"from": end1, "insert": " "}));

return array85577;

break;
default:
return out;

}
}),(cljs.core.truth_(trim_QMARK_)?[({"from":nextjournal.clojure_mode.node.end(cljs.core.first(nodes)),"to":to})]:[]),cljs.core.partition.cljs$core$IFn$_invoke$arity$3((2),(1),nodes));
});
nextjournal.clojure_mode.extensions.formatting.into_arr = (function nextjournal$clojure_mode$extensions$formatting$into_arr(arr,items){
var seq__85579_85622 = cljs.core.seq(items);
var chunk__85580_85623 = null;
var count__85581_85624 = (0);
var i__85582_85625 = (0);
while(true){
if((i__85582_85625 < count__85581_85624)){
var i_85626 = chunk__85580_85623.cljs$core$IIndexed$_nth$arity$2(null,i__85582_85625);
arr.push(i_85626);


var G__85628 = seq__85579_85622;
var G__85629 = chunk__85580_85623;
var G__85630 = count__85581_85624;
var G__85631 = (i__85582_85625 + (1));
seq__85579_85622 = G__85628;
chunk__85580_85623 = G__85629;
count__85581_85624 = G__85630;
i__85582_85625 = G__85631;
continue;
} else {
var temp__5753__auto___85632 = cljs.core.seq(seq__85579_85622);
if(temp__5753__auto___85632){
var seq__85579_85633__$1 = temp__5753__auto___85632;
if(cljs.core.chunked_seq_QMARK_(seq__85579_85633__$1)){
var c__4649__auto___85634 = cljs.core.chunk_first(seq__85579_85633__$1);
var G__85635 = cljs.core.chunk_rest(seq__85579_85633__$1);
var G__85636 = c__4649__auto___85634;
var G__85637 = cljs.core.count(c__4649__auto___85634);
var G__85638 = (0);
seq__85579_85622 = G__85635;
chunk__85580_85623 = G__85636;
count__85581_85624 = G__85637;
i__85582_85625 = G__85638;
continue;
} else {
var i_85639 = cljs.core.first(seq__85579_85633__$1);
arr.push(i_85639);


var G__85640 = cljs.core.next(seq__85579_85633__$1);
var G__85641 = null;
var G__85642 = (0);
var G__85643 = (0);
seq__85579_85622 = G__85640;
chunk__85580_85623 = G__85641;
count__85581_85624 = G__85642;
i__85582_85625 = G__85643;
continue;
}
} else {
}
}
break;
}

return arr;
});
/**
 * Returns mutated `changes` array
 */
nextjournal.clojure_mode.extensions.formatting.format_line = (function nextjournal$clojure_mode$extensions$formatting$format_line(state,indent_context,from,text,line_num,changes,format_spaces_QMARK_){
if((!((text == null)))){
} else {
throw (new Error("Assert failed: (some? text)"));
}

var current_indent = (/^\s*/.exec(text)[(0)]).length;
var indent = nextjournal.clojure_mode.util.guard(nextjournal.clojure_mode.extensions.formatting.get_indentation(indent_context,from),cljs.core.complement(cljs.core.neg_QMARK_));
var indentation_change = (cljs.core.truth_(indent)?(function (){var G__85586 = cljs.core.compare(indent,current_indent);
switch (G__85586) {
case (0):
return null;

break;
case (1):
return ({"from": (from + current_indent), "insert": nextjournal.clojure_mode.extensions.formatting.spaces(state,(indent - current_indent))});

break;
case (-1):
return ({"from": (from + indent), "to": (from + current_indent)});

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__85586)].join('')));

}
})():null);
var space_changes = (cljs.core.truth_(format_spaces_QMARK_)?nextjournal.clojure_mode.extensions.formatting.space_changes(state,(from + current_indent),(from + cljs.core.count(text))):null);
var G__85588 = changes;
var G__85588__$1 = (cljs.core.truth_(space_changes)?nextjournal.clojure_mode.extensions.formatting.into_arr(G__85588,space_changes):G__85588);
if(cljs.core.truth_(indentation_change)){
var array85589 = G__85588__$1;
array85589.push(indentation_change);

return array85589;
} else {
return G__85588__$1;
}
});
nextjournal.clojure_mode.extensions.formatting.format_selection = (function nextjournal$clojure_mode$extensions$formatting$format_selection(state){
var context = nextjournal.clojure_mode.extensions.formatting.make_indent_context(state);
return nextjournal.clojure_mode.util.update_selected_lines(state,(function (p__85591,changes,range){
var map__85592 = p__85591;
var map__85592__$1 = (((((!((map__85592 == null))))?(((((map__85592.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__85592.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__85592):map__85592);
var line = map__85592__$1;
var from = (function (){var obj85595 = map__85592__$1;
var k85596 = "from";
if((function (){var obj85597 = obj85595;
return (((!((obj85597 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85596,obj85597)));
})()){
return (obj85595[k85596]);
} else {
return undefined;
}
})();
var text = (function (){var obj85598 = map__85592__$1;
var k85599 = "text";
if((function (){var obj85600 = obj85598;
return (((!((obj85600 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85599,obj85600)));
})()){
return (obj85598[k85599]);
} else {
return undefined;
}
})();
var number = (function (){var obj85601 = map__85592__$1;
var k85602 = "number";
if((function (){var obj85604 = obj85601;
return (((!((obj85604 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k85602,obj85604)));
})()){
return (obj85601[k85602]);
} else {
return undefined;
}
})();
return nextjournal.clojure_mode.extensions.formatting.format_line(state,context,from,text,number,changes,true);
}));
});
nextjournal.clojure_mode.extensions.formatting.format_all = (function nextjournal$clojure_mode$extensions$formatting$format_all(state){
var context = nextjournal.clojure_mode.extensions.formatting.make_indent_context(state);
return nextjournal.clojure_mode.util.update_lines(state,(function (from,text,line_num){
return nextjournal.clojure_mode.extensions.formatting.format_line(state,context,from,text,line_num,[],true);
}));
});
nextjournal.clojure_mode.extensions.formatting.format_transaction = (function nextjournal$clojure_mode$extensions$formatting$format_transaction(tr){
var origin = nextjournal.clojure_mode.util.get_user_event_annotation(tr);
var temp__5751__auto__ = (function (){var G__85607 = origin;
switch (G__85607) {
case "input":
case "delete":
case "keyboardselection":
case "pointerselection":
case "cut":
case "noformat":
case "evalregion":
return null;

break;
case "format-selections":
return nextjournal.clojure_mode.extensions.formatting.format_selection(tr.state);

break;
default:
var state = tr.state;
var context = nextjournal.clojure_mode.extensions.formatting.make_indent_context(state);
return nextjournal.clojure_mode.util.iter_changed_lines(tr,(function (line,changes){
return nextjournal.clojure_mode.extensions.formatting.format_line(state,context,line.from,line.text,line.number,changes,true);
}));

}
})();
if(cljs.core.truth_(temp__5751__auto__)){
var changes = temp__5751__auto__;
return tr.startState.update((function (){var obj85608 = changes;
var obj85609 = (((!((obj85608 == null))))?obj85608:({}));
(obj85609["filter"] = false);

return obj85609;
})());
} else {
return tr;
}
});
nextjournal.clojure_mode.extensions.formatting.format = (function nextjournal$clojure_mode$extensions$formatting$format(state){
if(nextjournal.clojure_mode.util.something_selected_QMARK_(state)){
return state.update(nextjournal.clojure_mode.extensions.formatting.format_selection(state));
} else {
return nextjournal.clojure_mode.extensions.formatting.format_all(state);
}
});
nextjournal.clojure_mode.extensions.formatting.prefix_all = (function nextjournal$clojure_mode$extensions$formatting$prefix_all(prefix,state){
return nextjournal.clojure_mode.util.update_lines(state,(function (from,_,___$1){
return ({"from": from, "insert": prefix});
}));
});
nextjournal.clojure_mode.extensions.formatting.ext_format_changed_lines = (function nextjournal$clojure_mode$extensions$formatting$ext_format_changed_lines(){
return module$node_modules$$codemirror$state$dist$index_cjs.EditorState.transactionFilter.of(nextjournal.clojure_mode.extensions.formatting.format_transaction);
});

//# sourceMappingURL=nextjournal.clojure_mode.extensions.formatting.js.map
